function [ total_mismatches ] = error_mismatches( data_association, total_mismatches, step )
%ERROR_MISMATCHES This function counts the number of times where an
%hypothesis (ID) for an object change compared to the previous instant. 
%       INPUT
%       data_association        Object-Hypothesis mapping
%       step                    Current instant
%       total_mismatches            Number of mismatched hypotheses-objects in previous steps
%   OUTPUT
%       total_mismatches            Number of mismatched hypotheses-objects in current step
    
    current_mismatches = 0;
    
    if step>1
        current_data = round(data_association(:,1:2,step));
        previous_data = round(data_association(:,1:2,step-1));

        for i = 1:length(current_data(:,1))
            if (current_data(i,1) == previous_data(i,1)) && (current_data(i,2) ~= previous_data(i,2))
                current_mismatches = current_mismatches + 1;
            end
        end
    
        total_mismatches = total_mismatches + current_mismatches;
    else
        total_mismatches = current_mismatches;
    end
end

