function [ total_misses ] = error_misses( data_association, total_misses, step )
%ERROR_MISSES Counts the number of missed objects for which no tracking
%   hypothesis was found
%   INPUT
%       data_association        Object-Hypothesis mapping
%       step                    Current instant
%       total_misses            Number of missed objects in previous steps
%   OUTPUT
%       total_misses            Number of missed objects in current step
    current_misses = sum(data_association(:,1,step)>0) - sum(data_association(:,2,step)>0);
    total_misses = total_misses + current_misses;
    
end

