function varargout = input_GUI(varargin)
% INPUT_GUI MATLAB code for input_GUI.fig
%      INPUT_GUI, by itself, creates a new INPUT_GUI or raises the existing
%      singleton*.
%
%      H = INPUT_GUI returns the handle to a new INPUT_GUI or the handle to
%      the existing singleton*.
%
%      INPUT_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INPUT_GUI.M with the given input arguments.
%
%      INPUT_GUI('Property','Value',...) creates a new INPUT_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before input_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to input_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help input_GUI

% Last Modified by GUIDE v2.5 19-May-2017 17:31:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @input_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @input_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before input_GUI is made visible.
function input_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to input_GUI (see VARARGIN)

% Choose default command line output for input_GUI
handles.output = hObject;

% Pause button
global state;
state = struct('interrupted',false,'ini_frame',1,'view',2);
global isellipse;
isellipse = false;
global istarget;
istarget = false;   % Empty area or monitoring targets
global ini_step;
ini_step = 1;

% Create GENERAL tab group
handles.tgroup = uitabgroup('Parent',handles.panel_tag ,'TabLocation','top');
handles.tab1 = uitab('Parent',handles.tgroup,'Title','Input Simulation');
handles.tab2 = uitab('Parent',handles.tgroup,'Title','Radiation Model');
handles.tab3 = uitab('Parent',handles.tgroup,'Title','Sensor Configuration');
handles.tab4 = uitab('Parent',handles.tgroup,'Title','Algorithm Configuration');
handles.tab5 = uitab('Parent',handles.tgroup,'Title','Tracking Visualization');
handles.tab6 = uitab('Parent',handles.tgroup,'Title','Performance Analysis');

% Place panels into each tab
set(handles.panel1,'Parent',handles.tab1);
set(handles.panel2,'Parent',handles.tab2);
set(handles.panel3,'Parent',handles.tab3);
set(handles.panel4,'Parent',handles.tab4);
set(handles.panel5,'Parent',handles.tab5);
set(handles.panel6,'Parent',handles.tab6);


% Reposition of each panel to same location as panel 1
set(handles.panel2,'position',get(handles.panel1,'position'));
set(handles.panel3,'position',get(handles.panel1,'position'));
set(handles.panel4,'position',get(handles.panel1,'position'));
set(handles.panel5,'position',get(handles.panel1,'position'));
set(handles.panel6,'position',get(handles.panel1,'position'));

% Create RADIATION MODEL tab group
handles.tgroup_rad = uitabgroup('Parent',handles.panel2,'TabLocation','left');
handles.tab1_rad = uitab('Parent', handles.tgroup_rad,'Title','RF Model');
handles.tab2_rad = uitab('Parent', handles.tgroup_rad,'Title','T Model');
handles.tab3_rad = uitab('Parent', handles.tgroup_rad,'Title','LIDAR Model');

% Place panels into each tab
set(handles.panel_rf,'Parent', handles.tab1_rad);
set(handles.panel_t,'Parent', handles.tab2_rad);
set(handles.panel_lidar, 'Parent', handles.tab3_rad);

% Reposition of panels to same position as panel_rf
set(handles.panel_t, 'position',get(handles.panel_rf,'position'));
set(handles.panel_lidar, 'position', get(handles.panel_rf,'position'));

% Sensor button group
handles.rf_control = uicontrol('Parent',handles.uibuttongroup_sensors,'Style','radio','String','RF','Position',[10 110 50 20]);
handles.lidar_control = uicontrol('Parent',handles.uibuttongroup_sensors,'Style','radio','String','LIDAR','Position',[10 80 50 20]); 
handles.t_control = uicontrol('Parent',handles.uibuttongroup_sensors,'Style','radio','String','T','Position',[10 50 50 20]);

set(handles.lidar_control,'Enable','off'); % LIDAR sensors not implemented
set(handles.t_control, 'Enable','off'); % Temperature sensors not implemented

% Sensors overview UITABLE
set(handles.uitable_sensors,'ColumnName',{'','Type','X','Y','Active'},'ColumnWidth',{20,58,50,50,57},'Data',[],'ColumnEditable',true(1,5));

% Input simulation - Fixing axes parameters
axes(handles.axes1)
handles.axes1.FontSize = 8;
grid on
title('Paths of the targets in the monitored area')
xlabel('X')
ylabel('Y')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Radiation model - Fixing axes parameters
axes(handles.axes3)
handles.axes3.FontSize = 8;
grid on
title('Radiation')
xlabel('X')
ylabel('Y')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Sensor map - Fixing axes parameters
axes(handles.axes6)
handles.axes6.FontSize = 8;
grid on
title('Sensors Location')
xlabel('X')
ylabel('Y')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Input radiation - Fixing axes
axes(handles.axes11)
handles.axes11.FontSize = 8;
grid on
title('Input Radiation')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Estimated Radiation - Fixing axes
axes(handles.axes12)
handles.axes12.FontSize = 8;
grid on
title('Estimated Radiation')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Filtered RTI - Fixing axes
axes(handles.axes13)
handles.axes13.FontSize = 8;
grid on
title('Filtered RTI')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Clustering - Fixing axes
axes(handles.axes14)
handles.axes14.FontSize = 8;
grid on
title('Clustering')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Observations vs. Targets - Fixing axes
axes(handles.axes15)
handles.axes15.FontSize = 8;
grid on
title('Observations vs. Targets')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Target Tracking - Fixing axes
axes(handles.axes16)
handles.axes16.FontSize = 8;
grid on
title('Target Tracking')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])


% Tracking visualization - Kalman Estimation - Fixing axes
axes(handles.axes17)
handles.axes17.FontSize = 8;
grid on
title('Kalman Estimation')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Tracking visualization - Particle Estimation - Fixing axes
axes(handles.axes18)
handles.axes18.FontSize = 8;
grid on
title('Particle Estimation')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

% Performance Analysis - Histogram Simple Tracking - Deviation
axes(handles.axes20)
handles.axes20.FontSize = 8;
grid on
title('Tracking Errors')

% Performance Analysis - Histogram Kalman Filtering - Deviation
axes(handles.axes21)
handles.axes21.FontSize = 8;
grid on
title('Kalman Errors')

% Performance Analysis - Histogram Particle Filtering - Deviation
axes(handles.axes22)
handles.axes22.FontSize = 8;
grid on
title('Particle Errors')

% Setting initial possible option of a sensor
set(handles.text_newsensor_x,'String',num2str((handles.xmax+handles.xmin)/2));
set(handles.text_newsensor_y,'String',num2str((handles.ymax+handles.ymin)/2));

% Initialization "save file"
handles.saved_sensors = false;
handles.file = [];

% Initializing variables
handles.users_path = [];
handles.radiation = [];
handles.sensor_position = [];
handles.link_weights = [];
handles.filtered_rti = [];
handles.clusters_rti = [];
handles.total_clusters = cell(1,handles.nsteps);
handles.voxels_forcluster = [];
handles.rss_change_estimate = [];
handles.Ie = [];
handles.Tt = [];
handles.I_lpf = ones(1,handles.nsteps);

% Initializing tracking variables:
handles.targets = cell(1,handles.nsteps);
handles.kalman_targets = [];
handles.particle_targets = [];
handles.target_id = 1;
handles.confirmed_tracks = [];  % Confirmed tracks after N of M observations
handles.track_candidates = [];  % Track candidates to be confirmed or deleted
handles.deleted_tracks = [];    % Deleted track candidates if not confirmed

% Initializing Perfomance Analysis variables:
handles.data_association = zeros(handles.ntargets,5,handles.nsteps);  % Object-Hypothesis
handles.user_objects = cell(1,handles.nsteps); % Creating Objects IDs for Performance analysis 

% Update handles structure
guidata(hObject, handles);

uiwait;

% UIWAIT makes input_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = input_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = 0;


%% Input simulation
function text_targets_Callback(hObject, eventdata, handles)
% hObject    handle to text_targets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - Number of targets 
handles.ntargets = str2double(get(handles.text_targets,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end

% Hints: get(hObject,'String') returns contents of text_targets as text
%        str2double(get(hObject,'String')) returns contents of text_targets as a double


% --- Executes during object creation, after setting all properties.
function text_targets_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_targets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Input - Number of targets 
handles.ntargets = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function text_steps_Callback(hObject, eventdata, handles)
% hObject    handle to text_steps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - Maximum number of steps of a user
handles.nsteps = str2double(get(handles.text_steps,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end

% Hints: get(hObject,'String') returns contents of text_steps as text
%        str2double(get(hObject,'String')) returns contents of text_steps as a double


% --- Executes during object creation, after setting all properties.
function text_steps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_steps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Input - Maximum number of steps of a user
handles.nsteps = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_xmin_Callback(hObject, eventdata, handles)
% hObject    handle to text_xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - xmin
handles.xmin = str2double(get(handles.text_xmin,'String'));
set(handles.text_newsensor_x,'String',num2str((handles.xmax+handles.xmin)/2));

update_axes;

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end

% Hints: get(hObject,'String') returns contents of text_xmin as text
%        str2double(get(hObject,'String')) returns contents of text_xmin as a double


% --- Executes during object creation, after setting all properties.
function text_xmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Input - xmin
handles.xmin = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function text_xmax_Callback(hObject, eventdata, handles)
% hObject    handle to text_xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - xmax
handles.xmax = str2double(get(handles.text_xmax,'String'));
set(handles.text_newsensor_x,'String',num2str((handles.xmax+handles.xmin)/2));

update_axes;

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_xmax as text
%        str2double(get(hObject,'String')) returns contents of text_xmax as a double


% --- Executes during object creation, after setting all properties.
function text_xmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Input - xmax
handles.xmax = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_ymin_Callback(hObject, eventdata, handles)
% hObject    handle to text_ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - ymin
handles.ymin = str2double(get(handles.text_ymin,'String'));
set(handles.text_newsensor_y,'String',num2str((handles.ymax+handles.ymin)/2));

update_axes;

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_ymin as text
%        str2double(get(hObject,'String')) returns contents of text_ymin as a double


% --- Executes during object creation, after setting all properties.
function text_ymin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Input - ymin
handles.ymin = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_ymax_Callback(hObject, eventdata, handles)
% hObject    handle to text_ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - ymax
handles.ymax = str2double(get(handles.text_ymax,'String'));
set(handles.text_newsensor_y,'String',num2str((handles.ymax+handles.ymin)/2));

update_axes;

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end

% Hints: get(hObject,'String') returns contents of text_ymax as text
%        str2double(get(hObject,'String')) returns contents of text_ymax as a double

% --- Executes during object creation, after setting all properties.
function text_ymax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Input - ymax
handles.ymax = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in button_createpaths.
function button_createpaths_Callback(hObject, eventdata, handles)
% hObject    handle to button_createpaths (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    %% Input
    % Paths that the targets follow inside the considered map
    handles.dimensions = [handles.xmin handles.xmax ; handles.ymin handles.ymax];
    handles.users_path = create_path(handles.ntargets, handles.dimensions, handles.nsteps, handles.step_distance, handles.mean_distance);
    handles.user_objects = cell(1,handles.nsteps); % Creating Objects IDs for Performance analysis 
    users_voxels = floor(1/handles.precision.*(handles.users_path - handles.dimensions(:,1)))+1;    % Voxels in which the user is positioned
    
    for user = 1:handles.ntargets
        for s = 1:handles.nsteps
            if ~isnan(users_voxels(:,s,user))
                handles.user_objects{user,s} = struct('position',users_voxels(:,s,user),'ID',user);
            end
        end
    end
    
    axes(handles.axes1);
    handles.axes11.FontSize = 8;
    cla
 
    for i = 1:handles.ntargets
        plot(handles.users_path(1,:,i),handles.users_path(2,:,i))
        hold on
    end
    grid on
    title('Paths of the targets in the monitored area')
    xlabel('X')
    ylabel('Y')
    axis([handles.dimensions(1,1) handles.dimensions(1,2) handles.dimensions(2,1) handles.dimensions(2,2)])
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    axis([handles.dimensions(1,1) handles.dimensions(1,2) handles.dimensions(2,1) handles.dimensions(2,2)])
    
    % Update handles structure
    guidata(hObject, handles);


%% Radiation Model
function text_stepdistance_Callback(hObject, eventdata, handles)
% hObject    handle to text_stepdistance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Input - step distance in meters [m]
handles.step_distance = str2double(get(handles.text_stepdistance,'String'));

% Update handles structure
guidata(hObject,handles)

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_stepdistance as text
%        str2double(get(hObject,'String')) returns contents of text_stepdistance as a double


% --- Executes during object creation, after setting all properties.
function text_stepdistance_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_stepdistance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
%Input - step distance in meters [m]
handles.step_distance = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function text_meandistance_Callback(hObject, eventdata, handles)
% hObject    handle to text_meandistance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - Average straight distance of a target for modeling the paths
handles.mean_distance = str2double(get(handles.text_meandistance,'String'));

% Update handles structure
guidata(hObject,handles)

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createpaths_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_meandistance as text
%        str2double(get(hObject,'String')) returns contents of text_meandistance as a double


% --- Executes during object creation, after setting all properties.
function text_meandistance_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_meandistance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Input - Average straight distance of a target for modeling the paths
handles.mean_distance = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_amplitude_Callback(hObject, eventdata, handles)
% hObject    handle to text_amplitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Gaussian Amplitude
handles.rf_amplitude = str2double(get(handles.text_amplitude,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_amplitude as text
%        str2double(get(hObject,'String')) returns contents of text_amplitude as a double


% --- Executes during object creation, after setting all properties.
function text_amplitude_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_amplitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Gaussian Amplitude
handles.rf_amplitude = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_calibration_Callback(hObject, eventdata, handles)
% hObject    handle to text_calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Number of observations during training period (empty
% scenario)
handles.calibration = str2double(get(handles.text_calibration,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_calibration as text
%        str2double(get(hObject,'String')) returns contents of text_calibration as a double


% --- Executes during object creation, after setting all properties.
function text_calibration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Number of observations during training period (empty
% scenario)
handles.calibration = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_precision_Callback(hObject, eventdata, handles)
% hObject    handle to text_precision (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Precision of the map in voxels (pixels) per meter 
handles.precision = str2double(get(handles.text_precision,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_precision as text
%        str2double(get(hObject,'String')) returns contents of text_precision as a double


% --- Executes during object creation, after setting all properties.
function text_precision_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_precision (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Precision of the map in voxels (pixels) per meter 
handles.precision = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_targetwidthx_Callback(hObject, eventdata, handles)
% hObject    handle to text_targetwidthx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Target width in X axis in meters [m] 
handles.targetwidth_x = str2double(get(handles.text_targetwidthx,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_targetwidthx as text
%        str2double(get(hObject,'String')) returns contents of text_targetwidthx as a double


% --- Executes during object creation, after setting all properties.
function text_targetwidthx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_targetwidthx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Target width in X axis in meters [m] 
handles.targetwidth_x = str2double(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_targetwidthy_Callback(hObject, eventdata, handles)
% hObject    handle to text_targetwidthy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Target width in Y axis in meters [m] 
handles.targetwidth_y = str2double(get(handles.text_targetwidthy,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_targetwidthy as text
%        str2double(get(hObject,'String')) returns contents of text_targetwidthy as a double


% --- Executes during object creation, after setting all properties.
function text_targetwidthy_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_targetwidthy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Target width in Y axis in meters [m] 
handles.targetwidth_y = str2double(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_rotation_Callback(hObject, eventdata, handles)
% hObject    handle to text_rotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Rotation angle of a target in radians 
handles.rotation = str2double(get(handles.text_rotation,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_rotation as text
%        str2double(get(hObject,'String')) returns contents of text_rotation as a double


% --- Executes during object creation, after setting all properties.
function text_rotation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_rotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Rotation angle of a target in radians 
handles.rotation = str2double(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_noiselevel_Callback(hObject, eventdata, handles)
% hObject    handle to text_noiselevel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% RF Radiation Model - Noise deviation in the Gaussian function that model
% the radiation for each target (i.e. noiselevel*randn)
handles.noiselevel = str2double(get(handles.text_noiselevel,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_createradiation_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_noiselevel as text
%        str2double(get(hObject,'String')) returns contents of text_noiselevel as a double


% --- Executes during object creation, after setting all properties.
function text_noiselevel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_noiselevel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% RF Radiation Model - Noise deviation in the Gaussian function that model
% the radiation for each target (i.e. noiselevel*randn)
handles.noiselevel = str2double(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_createradiation.
function button_createradiation_Callback(hObject, eventdata, handles)
% hObject    handle to button_createradiation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isempty(handles.users_path)
    errordlg('Not input paths registered','Input Error');
    return;
end
% Parameter Settings
handles.target_width = [handles.targetwidth_x handles.targetwidth_y];
set(handles.text_ok,'Visible','off')
set(handles.button_play2d,'Enable','on')
set(handles.button_play3d,'Enable','on')
tic
% RF radiation
dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];

handles.radiation = create_radiation(dimensions, handles.users_path, handles.precision, handles.calibration, handles.rf_amplitude, handles.target_width, handles.rotation, handles.noiselevel );
toc
set(handles.text_ok,'Visible','on')
% Update handles structure
guidata(hObject, handles);
pause(1);
set(handles.text_ok,'Visible','off')


% --- Executes on button press in button_play2d.
function button_play2d_Callback(hObject, eventdata, handles)
% hObject    handle to button_play2d (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state;
state.view = 2;
% Radiation movie 2D
set(handles.button_pause,'Enable','on','String','Pause')
set(handles.button_stop,'Enable','on')
axes(handles.axes3);
handles.axes11.FontSize = 8;
cla
colorbar('peer', handles.axes3);
plottracking(1, handles.radiation, handles.users_path, handles.dimensions, handles.calibration, 2);
if state.interrupted == 0
    set(handles.button_pause,'Enable','off')
    set(handles.button_stop,'Enable','off')
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in button_play3d.
function button_play3d_Callback(hObject, eventdata, handles)
% hObject    handle to button_play3d (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state;
state.view = 3;
% Radiation movie 3D
set(handles.button_pause,'Enable','on','String','Pause')
set(handles.button_stop,'Enable','on')

axes(handles.axes3);
handles.axes11.FontSize = 8;
cla
plottracking(1, handles.radiation, handles.users_path, handles.dimensions, handles.calibration, 3);
if state.interrupted == 0
    set(handles.button_pause,'Enable','off');
    set(handles.button_stop,'Enable','off');
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in button_pause.
function button_pause_Callback(hObject, eventdata, handles)
% hObject    handle to button_pause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state;
    if state.interrupted
        set(handles.button_pause,'String','Pause');
        plottracking(state.ini_frame, handles.radiation, handles.users_path, handles.dimensions, handles.calibration, state.view);
        if state.interrupted == 0
            set(handles.button_pause,'Enable','off')
        end
    else
        set(handles.button_pause,'String','Continue');
        state.interrupted = true;
    end
% Update handles structure
guidata(hObject, handles);
    
% --- Executes on button press in button_stop.
function button_stop_Callback(hObject, eventdata, handles)
% hObject    handle to button_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state;
state.interrupted = true;
set(handles.button_stop,'Enable','off');
set(handles.button_pause,'Enable','off','String','Pause');
axes(handles.axes3)
handles.axes11.FontSize = 8;
cla
% Update handles structure
guidata(hObject, handles);


%% Sensor Configuration

% --- Executes on button press in pushbutton_addsensor.
function pushbutton_addsensor_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_addsensor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% If position out of limits
x_sensor = str2double(get(handles.text_newsensor_x,'String'));
y_sensor = str2double(get(handles.text_newsensor_y,'String'));
if (x_sensor<handles.xmin) || (x_sensor>handles.xmax) || (y_sensor<handles.ymin) || (y_sensor>handles.ymax)
    return;
end

global isellipse;
sensor_types = cellstr(get(handles.popupmenu_sensors,'String'));
handles.selected_sensor = sensor_types{get(handles.popupmenu_sensors,'Value')};

if strcmp(handles.selected_sensor, 'RF')
    sensor_color = [92 212 170]./255;
elseif strcmp(handles.selected_sensor, 'LIDAR')
    sensor_color = 'c';
else
    sensor_color = 'g';
end

% If sensor is RF type
if strcmp(handles.selected_sensor,'RF')
    handles.newsensor_x = str2double(get(handles.text_newsensor_x,'String'));
    handles.newsensor_y = str2double(get(handles.text_newsensor_y,'String'));
    
    if ~isempty(get(handles.uitable_sensors,'Data'))
        sdata = get(handles.uitable_sensors,'Data');
        for sx = 1:length(sdata(:,3))
            if (handles.newsensor_x==sdata{sx,3}) && (handles.newsensor_y==sdata{sx,4})
                warndlg('This sensor already exists','Sensor Error')
                return;
            end
        end
    end
    % Includes the sensor characteristics in the Table 'Sensors overview'
    if sum(size(get(handles.uitable_sensors,'Data'))) == 0
        set(handles.uitable_sensors,'Data',[{false},{handles.selected_sensor}, {handles.newsensor_x}, {handles.newsensor_y}, {true}]);
    else
        set(handles.uitable_sensors,'Data',[get(handles.uitable_sensors,'Data') ; {false},{handles.selected_sensor}, {handles.newsensor_x}, {handles.newsensor_y}, {true}]);
    end

    % Indicate that the file has not been saved yet
    saved_filename = get(handles.text_savename,'String');
    if (~(contains(saved_filename,'*'))) && (handles.saved_sensors)
        set(handles.text_savename,'String',strcat(saved_filename,'*'));
    end

    % Update sensor positions
    sensordata = get(handles.uitable_sensors,'Data');
    nsensors = length(sensordata(:,3));
    x_sensor_positions = [];
    y_sensor_positions = [];
    for sensor = 1:nsensors
        x_sensor_positions = [x_sensor_positions sensordata{sensor,3}];
        y_sensor_positions = [y_sensor_positions sensordata{sensor,4}];
    end

    handles.sensor_position = [x_sensor_positions; y_sensor_positions];
    set(handles.text_nsensors,'String',num2str(nsensors));
    % Enable "Show Ellipses" button if nsensors>1
    if nsensors>1
        set(handles.button_ellipses,'Enable','on');
        set(handles.text_ellipse,'Enable','on');
    else
        set(handles.button_ellipses,'Enable','off');
        set(handles.text_ellipse,'Enable','off');
    end

    % Plotting
    if isellipse
        nsensors = length(handles.sensor_position(1,:));
        nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
        dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
        lambda = str2double(get(handles.text_ellipse,'String'));
        handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,lambda);
        % Plotting Ellipses
        k_x = length(handles.xmin:handles.precision:handles.xmax);
        g_x = (handles.xmax-handles.xmin)/handles.precision;
        k_y = length(handles.ymin:handles.precision:handles.ymax);
        g_y = (handles.ymax-handles.ymin)/handles.precision;

        x = handles.xmin:handles.precision*k_x/g_x:handles.xmax;
        y = handles.ymin:handles.precision*k_y/g_y:handles.ymax;
        z = zeros(length(y),length(x));
        h = handles.link_weights;
        if length(handles.link_weights(:,1))>1
            h = sum(handles.link_weights);
        end

        for j = 1:length(y)
            for i = 1:length(x)
                z(i,j) = h(length(x)*(j-1)+i);
            end
        end

        axes(handles.axes6)
        handles.axes6.FontSize = 8;
        cla
        surf(x,y,z')
        view(2)
        colormap jet
        alpha(0.5)
        hold on
        plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
    else
        axes(handles.axes6)
        handles.axes6.FontSize = 8;
        hold on
        plot(handles.newsensor_x, handles.newsensor_y,'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',sensor_color) 
    end
else
    warndlg('Sensor not available','Sensor error')
    return;
end

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in button_clearall.
function button_clearall_Callback(hObject, eventdata, handles)
% hObject    handle to button_clearall (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global isellipse;
set(handles.button_ellipses,'String','Show Ellipses','Enable','Off');
set(handles.text_ellipse,'Enable','off');
isellipse = false;
axes(handles.axes6)
handles.axes6.FontSize = 8;
cla
set(handles.uitable_sensors,'Data',[]);
set(handles.text_savename,'String','Untitled...')
set(handles.text_nsensors,'String',num2str(0));
handles.saved_sensors = false; 

% Update handles structure
guidata(hObject, handles);


% --- Executes on selection change in popupmenu_sensors.
function popupmenu_sensors_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_sensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sensor_types = cellstr(get(handles.popupmenu_sensors,'String'));
handles.selected_sensor = sensor_types{get(handles.popupmenu_sensors,'Value')};
% Update handles structure
guidata(hObject, handles);
% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_sensors contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_sensors


% --- Executes during object creation, after setting all properties.
function popupmenu_sensors_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_sensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
sensor_types = cellstr(get(hObject,'String'));
handles.selected_sensor = sensor_types{get(hObject,'Value')};
% Update handles structure
guidata(hObject, handles);
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


function text_newsensor_x_Callback(hObject, eventdata, handles)
% hObject    handle to text_newsensor_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newsensor_x = str2double(get(handles.text_newsensor_x,'String'));
if (newsensor_x<=handles.xmax) && (newsensor_x>=handles.xmin)
    handles.newsensor_x = newsensor_x;
    handles.newsensor_x_before = newsensor_x;
else
    warndlg('Value out of limits','Wrong number');
    set(handles.text_newsensor_x,'String',num2str(handles.newsensor_x_before));
    return;
end
% Update handles structure
guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of text_newsensor_x as text
%        str2double(get(hObject,'String')) returns contents of text_newsensor_x as a double
% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    if (handles.newsensor_x<=handles.xmax) && (handles.newsensor_x>=handles.xmin)
        pushbutton_addsensor_Callback(hObject, eventdata, handles);
    end
end

% --- Executes during object creation, after setting all properties.
function text_newsensor_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_newsensor_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% handles    structure with handles and user data (see GUIDATA)

handles.newsensor_x = str2double(get(hObject,'String'));
handles.newsensor_x_before = handles.newsensor_x;
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_newsensor_y_Callback(hObject, eventdata, handles)
% hObject    handle to text_newsensor_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
newsensor_y = str2double(get(handles.text_newsensor_y,'String'));
if (newsensor_y<=handles.ymax) && (newsensor_y>=handles.ymin)
    handles.newsensor_y = newsensor_y;
    handles.newsensor_y_before = newsensor_y;
else
    warndlg('Value out of limits','Wrong number');
    set(handles.text_newsensor_y,'String',num2str(handles.newsensor_y_before));
    return;
end

% Update handles structure
guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of text_newsensor_y as text
%        str2double(get(hObject,'String')) returns contents of text_newsensor_y as a double
% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    if (handles.newsensor_y<=handles.ymax) && (handles.newsensor_y>=handles.ymin)
        pushbutton_addsensor_Callback(hObject, eventdata, handles);
    end
end


% --- Executes during object creation, after setting all properties.
function text_newsensor_y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_newsensor_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% handles    structure with handles and user data (see GUIDATA)
handles.newsensor_y = str2double(get(hObject,'String'));
handles.newsensor_y_before = handles.newsensor_y;
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton_addinmap.
function pushbutton_addinmap_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_addinmap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global isellipse;
axes(handles.axes6)
handles.axes6.FontSize = 8;
[handles.newsensor_x, handles.newsensor_y] = ginput(1);

% Show error if selected position is out of boundaries
if (handles.newsensor_x<handles.xmin) || (handles.newsensor_x>handles.xmax) || (handles.newsensor_y<handles.ymin) || (handles.newsensor_y>handles.ymax)
    errordlg('Error selecting sensor: Position out of limits', 'Sensor Error')
    return;
end

if ~isempty(get(handles.uitable_sensors,'Data'))
    sdata = get(handles.uitable_sensors,'Data');
    for sx = 1:length(sdata(:,3))
        if (handles.newsensor_x==sdata{sx,3}) && (handles.newsensor_y==sdata{sx,4})
            warndlg('This sensor already exists','Sensor Error')
            return;
        end
    end
end

if get(handles.rf_control,'Value')
    sensor_color = [92 212 170]./255;
    handles.selected_sensor = get(handles.rf_control,'String');
elseif get(handles.lidar_control,'Value')
    sensor_color = 'c';
    handles.selected_sensor = get(handles.lidar_control,'String');
else
    sensor_color = 'g';
    handles.selected_sensor = get(handles.t_control,'String');
end

% Includes the sensor characteristics in the Table 'Sensors overview'
if sum(size(get(handles.uitable_sensors,'Data'))) == 0
set(handles.uitable_sensors,'Data',[{false},{handles.selected_sensor}, {handles.newsensor_x}, {handles.newsensor_y}, {true}]);
else
set(handles.uitable_sensors,'Data',[get(handles.uitable_sensors,'Data') ; {false},{handles.selected_sensor}, {handles.newsensor_x}, {handles.newsensor_y}, {true}]);
end

% Update sensor positions
sensordata = get(handles.uitable_sensors,'Data');
nsensors = length(sensordata(:,3));
x_sensor_positions = [];
y_sensor_positions = [];
for sensor = 1:nsensors
    x_sensor_positions = [x_sensor_positions sensordata{sensor,3}];
    y_sensor_positions = [y_sensor_positions sensordata{sensor,4}];
end

handles.sensor_position = [x_sensor_positions; y_sensor_positions];
set(handles.text_nsensors,'String',num2str(nsensors));
% Enable "Show Ellipses" button if nsensors>1
if nsensors>1
    set(handles.button_ellipses,'Enable','on')
    set(handles.text_ellipse,'Enable','on')
else
    set(handles.button_ellipses,'Enable','off')
    set(handles.text_ellipse,'Enable','off')
end

% Plotting
if isellipse
    nsensors = length(handles.sensor_position(1,:));
    nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    lambda = str2double(get(handles.text_ellipse,'String'));
    handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,lambda);
    % Plotting ellipses
    k_x = length(handles.xmin:handles.precision:handles.xmax);
    g_x = (handles.xmax-handles.xmin)/handles.precision;
    k_y = length(handles.ymin:handles.precision:handles.ymax);
    g_y = (handles.ymax-handles.ymin)/handles.precision;

    x = handles.xmin:handles.precision*k_x/g_x:handles.xmax;
    y = handles.ymin:handles.precision*k_y/g_y:handles.ymax;
    z = zeros(length(y),length(x));
    h = handles.link_weights;
    if length(handles.link_weights(:,1))>1
        h = sum(handles.link_weights);
    end

    for j = 1:length(y)
        for i = 1:length(x)
            z(i,j) = h(length(x)*(j-1)+i);
        end
    end
    handles.axes6
    handles.axes6.FontSize = 8;
    cla
    surf(x,y,z')
    view(2)
    colormap jet
    alpha(0.5)
    hold on
    plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
else
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    hold on
    plot(handles.newsensor_x, handles.newsensor_y,'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',sensor_color) 
end

% Indicate that the file has not been saved yet
saved_filename = get(handles.text_savename,'String');
if (~(contains(saved_filename,'*'))) && (handles.saved_sensors)
    set(handles.text_savename,'String',strcat(saved_filename,'*'));
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in button_deletesensors.
function button_deletesensors_Callback(hObject, eventdata, handles)
% hObject    handle to button_deletesensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global isellipse;

sensordata = get(handles.uitable_sensors,'Data');
size_sensordata = size(sensordata);
nsensors = size_sensordata(1);
non_deleted_rows = [];
for sensor = 1:nsensors
    if sensordata{sensor,1} == 0
       non_deleted_rows = [non_deleted_rows sensor];
    end
end
sensordata = sensordata(non_deleted_rows,:);
size_sensordata = size(sensordata);
nsensors = size_sensordata(1);
set(handles.uitable_sensors,'Data',sensordata);

% Update sensor positions
x_sensor_positions = [];
y_sensor_positions = [];
for sensor = 1:nsensors
    x_sensor_positions = [x_sensor_positions sensordata{sensor,3}];
    y_sensor_positions = [y_sensor_positions sensordata{sensor,4}];
end

handles.sensor_position = [x_sensor_positions; y_sensor_positions];
set(handles.text_nsensors,'String',num2str(nsensors));
% Indicate that the file has not been saved yet
saved_filename = get(handles.text_savename,'String');
if (~(contains(saved_filename,'*'))) && (handles.saved_sensors)
    set(handles.text_savename,'String',strcat(saved_filename,'*'));
end

if nsensors<2
    isellipse = false;
    set(handles.button_ellipses,'String','Show Ellipses');
    if nsensors>0
        axes(handles.axes6)
        handles.axes6.FontSize = 8;
        cla
        plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
    else
        axes(handles.axes6)
        handles.axes6.FontSize = 8;
        cla
    end
elseif isellipse
    nsensors = length(handles.sensor_position(1,:));
    nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    lambda = str2double(get(handles.text_ellipse,'String'));
    handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,lambda);
    % Plotting ellipses
    k_x = length(handles.xmin:handles.precision:handles.xmax);
    g_x = (handles.xmax-handles.xmin)/handles.precision;
    k_y = length(handles.ymin:handles.precision:handles.ymax);
    g_y = (handles.ymax-handles.ymin)/handles.precision;

    x = handles.xmin:handles.precision*k_x/g_x:handles.xmax;
    y = handles.ymin:handles.precision*k_y/g_y:handles.ymax;
    z = zeros(length(y),length(x));
    h = handles.link_weights;
    if length(handles.link_weights(:,1))>1
        h = sum(handles.link_weights);
    end

    for j = 1:length(y)
        for i = 1:length(x)
            z(i,j) = h(length(x)*(j-1)+i);
        end
    end
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    cla
    surf(x,y,z')
    view(2)
    colormap jet
    alpha(0.5)
    hold on
    plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
    
else
    if ~isempty(handles.sensor_position)
        handles.axes6
        handles.axes6.FontSize = 8;
        cla
        plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
    end
end

% Enable "Show Ellipses" button if nsensors>1
if nsensors>1
    set(handles.button_ellipses,'Enable','on');
    set(handles.text_ellipse,'Enable','on');
else
    set(handles.button_ellipses,'Enable','off');
    set(handles.text_ellipse,'Enable','off');
end

% Update handles structure
guidata(hObject, handles);


function save_filename(hObject, eventdata, handles)
% hObject    handle to button_savesensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% --- Executes on button press in button_savesensors.
[handles.filename,handles.pathname] = uiputfile({'*.csv','CSV file (*.csv)'},'Saving sensors');
handles.file  = fullfile(handles.pathname,handles.filename);
% Update handles structure
guidata(hObject, handles);



function button_savesensors_Callback(hObject, eventdata, handles)
% hObject    handle to button_savesensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sensordata = get(handles.uitable_sensors,'Data');
file = handles.file;
if isempty(sensordata)
    warndlg('Not enough input sensors','Sensor Error')
    return;
elseif length(sensordata(:,3))<2
    warndlg('Not enough input sensors','Sensor Error')
    return;
end

if isempty(file)
    handles.saved_sensors = false;
    % Update handles structure
    guidata(hObject, handles);
end

if ~(handles.saved_sensors)
    handles.saved_sensors = true;
    pushbutton_saveas_Callback(hObject, eventdata, handles);
else 
    fid = fopen(file,'w');
    titles = {'Type','X','Y'};
    fprintf(fid, '%s,',titles{1:1:end-1});
    fprintf(fid, '%s\n', titles{1,end});
    sensordata = get(handles.uitable_sensors,'Data');
    data_size = size(sensordata);
    nsensors = data_size(1);
    for sensor = 1:nsensors
        fprintf(fid,'%s, %.2f, %.2f\n',sensordata{sensor,2:4});
    end
    fclose(fid);
    x_sensor_positions = [];
    y_sensor_positions = [];
    for i = 1:nsensors
        x_sensor_positions = [x_sensor_positions sensordata{i,3}];
        y_sensor_positions = [y_sensor_positions sensordata{i,4}];
    end
    handles.sensor_position = [x_sensor_positions; y_sensor_positions];
    set(handles.text_nsensors,'String',num2str(nsensors));
end

% Indicate that the file has been saved
saved_filename = get(handles.text_savename,'String');
if contains(saved_filename,'*')
    set(handles.text_savename,'String',erase(saved_filename,'*'));
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbutton_loadsensors.
function pushbutton_loadsensors_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_loadsensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename,pathname] = uigetfile('*.csv','Select CSV file');
file = fullfile(pathname,filename);

if (isequal(filename,0) || isequal(pathname,0))
    return;
end

fid = fopen(file,'r');
loaded_data = textscan(fid,'%s %s %s', 'delimiter',',');
fclose(fid);

if length(loaded_data{1}(:,1))<2
    errordlg('Not sensors registered','File error');
    return;
elseif length(loaded_data{1}(:,1))<3
    errordlg('Not enough sensors','File error');
    return;
end
nsensors = length(loaded_data{1}(:,1))-1;
sensor_position_x = [];
sensor_position_y = [];
for s = 2:(nsensors+1)
    sensor_position_x = [sensor_position_x str2double(loaded_data{1,2}{s,1})];
    sensor_position_y = [sensor_position_y str2double(loaded_data{1,3}{s,1})];
end

handles.sensor_position = [sensor_position_x; sensor_position_y];
set(handles.text_nsensors,'String',num2str(nsensors));
axes(handles.axes6)
handles.axes6.FontSize = 8;
cla
plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerEdgeColor',[19 53 59]./255,'MarkerFaceColor',[92 212 170]./255)
hold on 
grid on
title('Sensors Location')
xlabel('X')
ylabel('Y')
axis([handles.xmin handles.xmax handles.ymin handles.ymax])

sensor_data = [];
for s = 2:length(loaded_data{1}(:,1))
    sensor_data = [sensor_data; {false},{loaded_data{1,1}{s,1}},{handles.sensor_position(1,s-1)},{handles.sensor_position(2,s-1)},{true}];
end
set(handles.uitable_sensors,'Data',sensor_data);

handles.saved_sensors = true;

set(handles.text_savename,'String',filename);
handles.file = file;

if length(handles.sensor_position(1,:))>1
    set(handles.button_ellipses,'Enable','on');
    set(handles.text_ellipse,'Enable','on');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pushbutton_saveas.
function pushbutton_saveas_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_saveas (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sensordata = get(handles.uitable_sensors,'Data');
if isempty(sensordata)
    warndlg('Not enough input sensors','Sensor Error')
    return;
elseif length(sensordata(:,3))<2
    warndlg('Not enough input sensors','Sensor Error')
    return;
end

[filename,pathname] = uiputfile({'*.csv','CSV file (*.csv)'},'Saving sensors');
file  = fullfile(pathname,filename);

if ~(isequal(filename,0) || isequal(pathname,0))
    fid = fopen(file,'w');
    titles = {'Type','X','Y'};
    fprintf(fid, '%s,',titles{1:1:end-1});
    fprintf(fid, '%s\n', titles{1,end});
    sensordata = get(handles.uitable_sensors,'Data');
    data_size = size(sensordata);
    nsensors = data_size(1);
    for sensor = 1:nsensors
        fprintf(fid,'%s, %.2f, %.2f\n',sensordata{sensor,2:4});
    end
    fclose(fid);
    x_sensor_positions = [];
    y_sensor_positions = [];
    for i = 1:nsensors
        x_sensor_positions = [x_sensor_positions sensordata{i,3}];
        y_sensor_positions = [y_sensor_positions sensordata{i,4}];
    end
    handles.sensor_position = [x_sensor_positions; y_sensor_positions];
    set(handles.text_nsensors,'String',num2str(nsensors));
else
    handles.saved_sensors = false;
end
if ~(filename == 0)
    set(handles.text_savename,'String',filename);
    handles.file = file;
end

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in button_ellipses.
function button_ellipses_Callback(hObject, eventdata, handles)
% hObject    handle to button_ellipses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global isellipse;

if strcmp(get(handles.button_ellipses,'String'),'Show Ellipses')
    
    set(handles.button_ellipses,'String','Hide Ellipses');
    
    nsensors = length(handles.sensor_position(1,:));
    nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    lambda = str2double(get(handles.text_ellipse,'String'));
    handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,lambda);

    % Plotting Ellipses
    k_x = length(handles.xmin:handles.precision:handles.xmax);
    g_x = (handles.xmax-handles.xmin)/handles.precision;
    k_y = length(handles.ymin:handles.precision:handles.ymax);
    g_y = (handles.ymax-handles.ymin)/handles.precision;

    x = handles.xmin:handles.precision*k_x/g_x:handles.xmax;
    y = handles.ymin:handles.precision*k_y/g_y:handles.ymax;
    z = zeros(length(y),length(x));
    h = handles.link_weights;
    if length(handles.link_weights(:,1))>1
        h = sum(handles.link_weights);
    end

    for j = 1:length(y)
        for i = 1:length(x)
            z(i,j) = h(length(x)*(j-1)+i);
        end
    end
    
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    cla
    surf(x,y,z')
    view(2)
    colormap jet
    alpha(0.5)
    hold on
    plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerFaceColor',[92 212 170]./255,'MarkerEdgeColor',[19 53 59]./255)
    
    isellipse = true;
else
    set(handles.button_ellipses,'String','Show Ellipses') 
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    cla
    plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerFaceColor',[92 212 170]./255,'MarkerEdgeColor',[19 53 59]./255)
    isellipse = false;
end

% Update handles structure
guidata(hObject, handles);


function text_ellipse_Callback(hObject, eventdata, handles)
% hObject    handle to text_ellipse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Input - Maximum number of steps of a user
handles.ellipse_excess_path = str2double(get(handles.text_ellipse,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    if strcmp(get(handles.button_ellipses,'String'),'Show Ellipses')
    button_ellipses_Callback(hObject, eventdata, handles);
    else
        nsensors = length(handles.sensor_position(1,:));
    nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    
    handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,handles.ellipse_excess_path);

    % Plotting Ellipses
    k_x = length(handles.xmin:handles.precision:handles.xmax);
    g_x = (handles.xmax-handles.xmin)/handles.precision;
    k_y = length(handles.ymin:handles.precision:handles.ymax);
    g_y = (handles.ymax-handles.ymin)/handles.precision;

    x = handles.xmin:handles.precision*k_x/g_x:handles.xmax;
    y = handles.ymin:handles.precision*k_y/g_y:handles.ymax;
    z = zeros(length(y),length(x));
    h = handles.link_weights;
    if length(handles.link_weights(:,1))>1
        h = sum(handles.link_weights);
    end

    for j = 1:length(y)
        for i = 1:length(x)
            z(i,j) = h(length(x)*(j-1)+i);
        end
    end
    
    axes(handles.axes6)
    handles.axes6.FontSize = 8;
    cla
    surf(x,y,z')
    view(2)
    colormap jet
    alpha(0.5)
    hold on
    plot(handles.sensor_position(1,:),handles.sensor_position(2,:),'o','MarkerFaceColor',[92 212 170]./255,'MarkerEdgeColor',[19 53 59]./255)
    end
end
% Hints: get(hObject,'String') returns contents of text_ellipse as text
%        str2double(get(hObject,'String')) returns contents of text_ellipse as a double


% --- Executes during object creation, after setting all properties.
function text_ellipse_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_ellipse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Sensor configuration - Ellipse Excess Pat 
handles.ellipse_excess_path = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_apply_algorithm.
function button_apply_algorithm_Callback(hObject, eventdata, handles)
% hObject    handle to button_apply_algorithm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    tic
    h = waitbar(0,'Tracking Targets...');
    waitbar(0.1)
    global istarget;
    global ini_step;
    ini_step = 1;
    if isempty(handles.sensor_position)
        errordlg('No sensors registered','Sensor Error');
        return;
    end
    nsensors = length(handles.sensor_position(1,:));
    if nsensors<2
        warndlg('Not enough sensors','Sensor Error');
        return;
    end
    nlinks = (nsensors^2-nsensors)/2;   % Number of links: L = (K^2-K)/2 (K: number of sensors)
    % Received signal (in terms of change of received signal strength) for each link
    if isempty(handles.radiation)
        errordlg('Radiation not registered','Radiation error');
        return;
    end
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    % Initializing tracking variables:
    handles.targets = cell(1,handles.nsteps);
    handles.kalman_targets = [];
    handles.particle_targets = [];
    handles.target_id = 1;
    handles.confirmed_tracks = [];  % Confirmed tracks after N of M observations
    handles.track_candidates = [];  % Track candidates to be confirmed or deleted
    handles.deleted_tracks = [];    % Deleted track candidates if not confirmed
    
    % Initializing particle filter variables:
    ids = [];
    particle_filters = [];
    particle_boundaries_x = floor(1/handles.precision.*([handles.xmin;handles.xmax-handles.precision] - dimensions(1,1)))+1;    % Particle boundaries in X-axis
    particle_boundaries_y = floor(1/handles.precision.*([handles.ymin;handles.ymax-handles.precision] - dimensions(2,1)))+1;    % Particle boundaries in Y-axis
    particle_boundaries = [particle_boundaries_x' ; particle_boundaries_y'];
    
    % Initializing Perfomance Analysis variables:
    handles.data_association = zeros(handles.ntargets,5,handles.nsteps);  % Object-Hypothesis
    
    waitbar(0.1)
    %if isempty(handles.link_weights)
    handles.link_weights = locate_link_ellipses(dimensions,handles.sensor_position,handles.precision,nlinks,handles.ellipse_excess_path);
    %end
    waitbar(0.2)
    rss_change_link = rss_links(handles.radiation,handles.link_weights,nlinks); 
    % For real environment with real sensor measurements of signal strength for
    % each link, this value is calculated as
    % 1/sum(F_l_c)*sum(F_l_c*diff(Rss-avg_Rss)), where F_l_c is the fade level
    % for link l in channel c (if sensors can receive in different frequency
    % channels), Rss is the received signal strength at that instant and
    % avg_Rss is the average RSS measure at the begining (calibration scenario)

    % Quantizer 
    sensors_data = sensor_quantization(rss_change_link, handles.Nbits);
    
    %% Channel BER

    % Resizing sensors_data matrix
    line_sensors_data = [];
    for l = 1:length(sensors_data(:,1))
        line_sensors_data = [line_sensors_data sensors_data(l,:)];
    end

    % Converting decimals to binary
    bits_sensors_data = zeros(1,handles.Nbits*length(line_sensors_data));
    for b = 1:length(line_sensors_data)
        current_bits = de2bi(line_sensors_data(b),'left-msb');
        if current_bits < handles.Nbits
            nbits_zeros = zeros(1,handles.Nbits-length(current_bits));
            current_bits = [nbits_zeros current_bits];
        end
        bits_sensors_data(1,(handles.Nbits*(b-1)+1):(handles.Nbits*b)) = current_bits;
    end

    % Channel errors
    nbits_error = handles.channel_BER*length(bits_sensors_data);
    rand_position = randi([1 length(bits_sensors_data)], 1, floor(nbits_error));

    % Data with errors
    bits_sensors_data(rand_position) = 1 - bits_sensors_data(rand_position);

    % Reconstructing values in a row matrix
    reconstructed_line_sensors_data = zeros(size(line_sensors_data));
    for e = 1:length(line_sensors_data)
        reconstructed_line_sensors_data(e) = bi2de(bits_sensors_data((handles.Nbits*(e-1)+1):(e*handles.Nbits)),'left-msb');
    end

    % Resizing data sensors matrix
    new_sensors_data = zeros(size(sensors_data));
    for g = 1:length(sensors_data(:,1))
        new_sensors_data(g,:) = reconstructed_line_sensors_data(1,(length(sensors_data(1,:))*(g-1)+1):(length(sensors_data(1,:))*g));
    end

    sensors_data = new_sensors_data;
    
    %% RTI Estimation
    waitbar(0.3)
    target_id = 1;
    % The fusion center (FC) estimates the radiation from the sensors measurements
    %rss_change_estimate = rss_estimation(dimensions, rss_change_link, link_weights, precision);
    handles.rss_change_estimate = rss_estimation(dimensions, sensors_data, handles.link_weights, handles.precision, handles.sigma_n, handles.sigma_x, handles.delta);
    waitbar(0.4)
    % Initialization of variables
    handles.filtered_rti = zeros(size(handles.rss_change_estimate(:,:,handles.calibration+1:end)));

    % Threshold when the monitored area is empty
    if handles.calibration == 0
        handles.Ie = 1;
    else
        handles.Ie = mean(max(max(handles.rss_change_estimate(:,:,1:handles.calibration)))); % Average maximum intensity in the training period
    end

    handles.Tt = [2*handles.Ie 0];  % Initial Detection Threshold
    nsteps = handles.nsteps;
    
    % Performance Analysis - initializing variables
    total_deviation = 0;
    total_deviation_kalman = 0;
    total_deviation_particle = 0;
    n_matches = 0; 
    total_false_positives = 0;
    total_misses = 0;
    total_mismatches = 0;
    
    for step = 1:nsteps
        % Thresholding
        handles.filtered_rti(:,:,step) = detection_thresholding(handles.rss_change_estimate(:,:,handles.calibration+step),handles.Tt);    
        % Clustering  
        [handles.clusters_rti{1,step}, handles.total_clusters{1,step}, handles.voxels_forcluster{1,step}] = clustering(handles.filtered_rti(:,:,step), handles.precision, handles.cluster_width);
        % Tracking
        [handles.targets, handles.track_candidates, handles.confirmed_tracks, handles.deleted_tracks, target_id ] = target_tracking( handles.targets, handles.total_clusters, step,...
        dimensions, handles.precision, handles.Re, handles.radius_t, handles.n_memory, handles.n_confirm, handles.n_max_confirm, handles.n_delete, target_id, handles.track_candidates, ...
        handles.confirmed_tracks, handles.deleted_tracks );

        % Kalman filtering
        for t = 1:length(handles.targets(:,step))
            handles.kalman_targets{t,step} = handles.targets{t,step};
        end
        handles.kalman_targets = kalman_filtering( handles.kalman_targets, handles.precision, handles.n_memory, step );

        % Particle filtering
        for t = 1:length(handles.targets(:,step))
            handles.particle_targets{t,step} = handles.targets{t,step};
        end
        [ handles.particle_targets, particle_filters, ids] = particle_filtering( handles.particle_targets, particle_filters, particle_boundaries, ids, handles.n_memory, step );
        
        % Object-Hypothesis association
        handles.data_association = object_hypothesis_association(handles.user_objects, handles.targets, handles.kalman_targets, handles.particle_targets, step, handles.data_association);
        
        % Performance Analysis
        [ total_deviation, total_deviation_kalman, total_deviation_particle,...
            n_matches, MOTP, MOTP_kalman, MOTP_particle, max_deviation, ...
            max_deviation_kalman, max_deviation_particle ]  ...
            = tracking_deviation( handles.data_association, step, total_deviation, ...
            total_deviation_kalman, total_deviation_particle, n_matches, handles.precision );
        
        [ total_false_positives ] = error_false_positives( handles.targets, handles.data_association, step, total_false_positives );
        [ total_misses ] = error_misses( handles.data_association, total_misses, step );
        [ total_mismatches ] = error_mismatches( handles.data_association, total_mismatches, step );
        
        if istarget     
            % Iterative thresholding
            Imin_previous = zeros(1,length(handles.voxels_forcluster{1,step}(:,1)));
            for pos = 1:length(handles.voxels_forcluster{1,step}(:,1))
                Imin_previous(pos) = handles.filtered_rti(handles.voxels_forcluster{1,step}(pos,1),handles.voxels_forcluster{1,step}(pos,2),step); 
            end   
            Imin = min(Imin_previous);
            handles.I_lpf(step+1) = handles.alfa*handles.I_lpf(step)+(1-handles.alfa)*Imin; % Low-pass filter of Imin
            handles.Tt(2) = handles.beta*handles.I_lpf(step+1); 
        end
        waitbar(0.5 + (step/nsteps)/2); 
    end
    waitbar(1)
    close(h)

    set(handles.text_ok_apply,'Visible','On');
    pause(1)
    set(handles.text_ok_apply,'Visible','Off');

    set(handles.button_play_tracking,'Enable','On');
    
    set(handles.text_Emax,'String',num2str(round(max_deviation,3))); % Updating maximum cardinality error with simple Tracking
    set(handles.text_Emean,'String',num2str(round(MOTP,3))); % Updating average cardinality error with simple Tracking
    set(handles.text_Emax_kalman,'String',num2str(round(max_deviation_kalman,3))); % Updating maximum cardinality error with Kalman Filtering
    set(handles.text_Emean_kalman,'String',num2str(round(MOTP_kalman,3))); % Updating mean cardinality error with Kalman Filtering
    set(handles.text_Emax_particle,'String',num2str(round(max_deviation_particle,3))); % Updating maximum cardinality error with Particle Filtering
    set(handles.text_Emean_particle,'String',num2str(round(MOTP_particle,3))); % Updating mean cardinality error with Particle Filtering
    set(handles.text_misses,'String',num2str(total_misses)); % Missed objects
    set(handles.text_falsepositives,'String',num2str(total_false_positives)); % False positives errors
    set(handles.text_mismatches,'String',num2str(total_mismatches)); % Mismatches errors
    
    totalobjects = sum(sum(handles.data_association(:,1,:)>0));
    MOTA = (1-(total_misses+total_false_positives+total_mismatches)/totalobjects)*100;
    
    set(handles.text_totalobjects1,'String',num2str(totalobjects));
    set(handles.text_totalobjects2,'String',num2str(totalobjects));
    set(handles.text_totalobjects3,'String',num2str(totalobjects));
    set(handles.text_MOTA,'String',num2str(MOTA));
    
    % Performance Analysis - Plotting histograms
    % Performance Analysis - Histogram Simple Tracking - Deviation
    axes(handles.axes20)
    histogram(handles.data_association(:,3,:),25)
    grid on;
    if max(max(handles.data_association(:,3,:)))>0
        xlimmax = max(max(handles.data_association(:,3,:)));
    else
        xlimmax = 1;
    end
        
    xlim([0 xlimmax]);
    title('Tracking Errors')
    handles.axes20.FontSize = 8;

    % Performance Analysis - Histogram Kalman Filtering - Deviation
    axes(handles.axes21)
    histogram(handles.data_association(:,4,:),25)
    grid on;
    if max(max(handles.data_association(:,4,:)))>0
        xlimmax = max(max(handles.data_association(:,4,:)));
    else
        xlimmax = 1;
    end
    xlim([0 xlimmax]);
    title('Kalman Errors')
    handles.axes21.FontSize = 8;
    
    % Performance Analysis - Histogram Particle Filtering - Deviation
    axes(handles.axes22)
    histogram(handles.data_association(:,5,:),25)
    grid on;
    if max(max(handles.data_association(:,5,:)))>0
        xlimmax = max(max(handles.data_association(:,5,:)));
    else
        xlimmax = 1;
    end
    xlim([0 xlimmax]);
    title('Particle Errors')
    handles.axes22.FontSize = 8;
    
    % Clearing Visualization axes
    axes(handles.axes11)
    cla
    axes(handles.axes12)
    cla
    axes(handles.axes13)
    cla
    axes(handles.axes14)
    cla
    axes(handles.axes15)
    cla
    axes(handles.axes16)
    cla
    axes(handles.axes17)
    cla
    axes(handles.axes18)
    cla
    toc
% Update handles structure
guidata(hObject, handles);


function text_cluster_width_Callback(hObject, eventdata, handles)
% hObject    handle to text_cluster_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Input - Number of targets 
handles.cluster_width = str2double(get(handles.text_cluster_width,'String'));

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end

% Hints: get(hObject,'String') returns contents of text_cluster_width as text
%        str2double(get(hObject,'String')) returns contents of text_cluster_width as a double


% --- Executes during object creation, after setting all properties.
function text_cluster_width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_cluster_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.cluster_width = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_Re_Callback(hObject, eventdata, handles)
% hObject    handle to text_Re (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Input - Number of targets 
handles.Re = str2double(get(handles.text_Re,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_Re as text
%        str2double(get(hObject,'String')) returns contents of text_Re as a double


% --- Executes during object creation, after setting all properties.
function text_Re_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_Re (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.Re = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_radius_t_Callback(hObject, eventdata, handles)
% hObject    handle to text_radius_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.radius_t = str2double(get(handles.text_radius_t,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_radius_t as text
%        str2double(get(hObject,'String')) returns contents of text_radius_t as a double


% --- Executes during object creation, after setting all properties.
function text_radius_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_radius_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.radius_t = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_n_memory_Callback(hObject, eventdata, handles)
% hObject    handle to text_n_memory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.n_memory = str2double(get(handles.text_n_memory,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_n_memory as text
%        str2double(get(hObject,'String')) returns contents of text_n_memory as a double


% --- Executes during object creation, after setting all properties.
function text_n_memory_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_n_memory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.n_memory = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_n_confirm_Callback(hObject, eventdata, handles)
% hObject    handle to text_n_confirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.n_confirm = str2double(get(handles.text_n_confirm,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_n_confirm as text
%        str2double(get(hObject,'String')) returns contents of text_n_confirm as a double


% --- Executes during object creation, after setting all properties.
function text_n_confirm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_n_confirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.n_confirm = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_n_max_confirm_Callback(hObject, eventdata, handles)
% hObject    handle to text_n_max_confirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.n_max_confirm = str2double(get(handles.text_n_max_confirm,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_n_max_confirm as text
%        str2double(get(hObject,'String')) returns contents of text_n_max_confirm as a double


% --- Executes during object creation, after setting all properties.
function text_n_max_confirm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_n_max_confirm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.n_max_confirm = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_n_delete_Callback(hObject, eventdata, handles)
% hObject    handle to text_n_delete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.n_delete = str2double(get(handles.text_n_delete,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_n_delete as text
%        str2double(get(hObject,'String')) returns contents of text_n_delete as a double


% --- Executes during object creation, after setting all properties.
function text_n_delete_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_n_delete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.n_delete = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_alfa_Callback(hObject, eventdata, handles)
% hObject    handle to text_alfa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.alfa = str2double(get(handles.text_alfa,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_alfa as text
%        str2double(get(hObject,'String')) returns contents of text_alfa as a double


% --- Executes during object creation, after setting all properties.
function text_alfa_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_alfa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.alfa = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_beta_Callback(hObject, eventdata, handles)
% hObject    handle to text_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.beta = str2double(get(handles.text_beta,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_beta as text
%        str2double(get(hObject,'String')) returns contents of text_beta as a double


% --- Executes during object creation, after setting all properties.
function text_beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.beta = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_sigma_n_Callback(hObject, eventdata, handles)
% hObject    handle to text_sigma_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sigma_n = str2double(get(handles.text_sigma_n,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_sigma_n as text
%        str2double(get(hObject,'String')) returns contents of text_sigma_n as a double


% --- Executes during object creation, after setting all properties.
function text_sigma_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_sigma_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.sigma_n = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_sigma_x_Callback(hObject, eventdata, handles)
% hObject    handle to text_sigma_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sigma_x = str2double(get(handles.text_sigma_x,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_sigma_x as text
%        str2double(get(hObject,'String')) returns contents of text_sigma_x as a double


% --- Executes during object creation, after setting all properties.
function text_sigma_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_sigma_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.sigma_x = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function text_delta_Callback(hObject, eventdata, handles)
% hObject    handle to text_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.delta = str2double(get(handles.text_delta,'String')); % Entrance/Exit Region Width

% Update handles structure
guidata(hObject, handles);

% Press enter button 
key = get(gcf,'CurrentKey');
if(strcmp (key , 'return'))
    button_apply_algorithm_Callback(hObject, eventdata, handles);
end
% Hints: get(hObject,'String') returns contents of text_delta as text
%        str2double(get(hObject,'String')) returns contents of text_delta as a double


% --- Executes during object creation, after setting all properties.
function text_delta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.delta = str2double(get(hObject,'String'));
% Update handles structure
guidata(hObject, handles);
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_play_tracking.
function button_play_tracking_Callback(hObject, eventdata, handles)
% hObject    handle to button_play_tracking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    global ini_step;
    if strcmp(get(handles.button_play_tracking,'String'),'Play')
        set(handles.button_play_tracking,'String','Pause');
    else
        set(handles.button_play_tracking,'String','Play');
    end
    
    if strcmp(get(handles.button_stop_tracking,'Enable'),'off')
        ini_step = 1;
    end
    set(handles.button_stop_tracking,'Enable','On');

    % Axis points
    dimensions = [handles.xmin handles.xmax; handles.ymin handles.ymax];
    xaxis = (dimensions(1,1)+handles.precision/2):handles.precision:(dimensions(1,2)-handles.precision/2);
    yaxis = (dimensions(2,1)+handles.precision/2):handles.precision:(dimensions(2,2)-handles.precision/2);

    % Plotting paths
    axes(handles.axes17)
    handles.axes17.FontSize = 8;
    grid on
    title('Kalman Estimation')
    axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
    hold on
    for i = 1:handles.ntargets
        plot(handles.users_path(1,:,i),handles.users_path(2,:,i))
        hold on
    end

    axes(handles.axes18)
    handles.axes18.FontSize = 8;
    grid on
    title('Particle Estimation')
    axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
    hold on
    for i = 1:handles.ntargets
        plot(handles.users_path(1,:,i),handles.users_path(2,:,i))
        hold on
    end

    % Plotting figures
    for s = ini_step:handles.nsteps
        if strcmp(get(handles.button_play_tracking,'String'),'Play')
            ini_step = s;
            return;
        else 
        pause(0.01)

            axes(handles.axes11)
            cla
            axes(handles.axes12)
            cla
            axes(handles.axes13)
            cla
            axes(handles.axes14)
            cla
            axes(handles.axes15)
            cla

            % Plotting

            % Input radiation 
            axes(handles.axes11)
            handles.axes11.FontSize = 8;
            surf(xaxis,yaxis,handles.radiation(:,:,handles.calibration+s)','EdgeColor','none')
            hold on
            view(2);
            colormap jet;
            caxis([0 max(max(handles.radiation(:,:,handles.calibration+s)))]);
            grid on
            title('Input Radiation')
            axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])

            % Estimated radiation
            axes(handles.axes12)
            handles.axes12.FontSize = 8;
            hold on
            surf(xaxis,yaxis,handles.rss_change_estimate(:,:,handles.calibration+s)','EdgeColor','none')
            view(2);
            colormap jet;
            caxis([0 max(max(handles.rss_change_estimate(:,:,handles.calibration+s)))]);
            grid on
            title('Estimated radiation')
            axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])

            % Filtered RTI
            axes(handles.axes13)
            handles.axes13.FontSize = 8;
            surf(xaxis,yaxis,handles.filtered_rti(:,:,s)','EdgeColor','none')
            view(2)
            if max(max(handles.filtered_rti(:,:,s)))<handles.rf_amplitude
                cmax = handles.rf_amplitude;
            else
                cmax = max(max(handles.filtered_rti(:,:,s)));
            end 
            caxis([0 cmax]);
            hold on
            t = linspace(0,2*pi);
            for w = 1:length(handles.targets(:,s))
                if isstruct(handles.targets{w,s})
                    radius_inmeters = (handles.targets{w,s}.radius).*handles.precision;
                    position_x_inmeters = ((handles.targets{w,s}.position(1)).*handles.precision+dimensions(1,1))-handles.precision/2;
                    position_y_inmeters = ((handles.targets{w,s}.position(2)).*handles.precision+dimensions(2,1))-handles.precision/2;
                    plot(position_x_inmeters+radius_inmeters.*cos(t),position_y_inmeters+radius_inmeters.*sin(t))
                    hold on
                end
            end
            grid on;
            axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
            title('Filtered RTI')

            % Clustering
            axes(handles.axes14)
            handles.axes14.FontSize = 8;
            if isempty(handles.voxels_forcluster{1,s})
                plot(0,0)
                grid on;
                axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                title('Clustering')
                handles.axes14.FontSize = 8;
            else
                rows_inmeters = (handles.voxels_forcluster{1,s}(:,1).*handles.precision+dimensions(1,1))-handles.precision/2;
                columns_inmeters = (handles.voxels_forcluster{1,s}(:,2).*handles.precision+dimensions(2,1))-handles.precision/2;
                scatter(rows_inmeters,columns_inmeters,10,handles.clusters_rti{1,s})
                hold on
                grid on;
                axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                title('Clustering')
                handles.axes14.FontSize = 8;
                hold on
                t = linspace(0,2*pi);
                for w = 1:length(handles.targets(:,s))
                    if isstruct(handles.targets{w,s})
                        position_x_inmeters = ((handles.targets{w,s}.position(1)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        position_y_inmeters = ((handles.targets{w,s}.position(2)).*handles.precision+dimensions(2,1))-handles.precision/2;
                        plot(position_x_inmeters+radius_inmeters.*cos(t),position_y_inmeters+radius_inmeters.*sin(t))
                        hold on
                    end
                end
            end

            % Observations vs. Targets
            axes(handles.axes15)
            handles.axes15.FontSize = 8;
            if s>1
                for c = 1:length(handles.targets(:,s-1))
                    if isstruct(handles.targets{c,s-1})
                        target_x_position_inmeters = ((handles.targets{c,s-1}.position(1)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        target_y_position_inmeters = ((handles.targets{c,s-1}.position(2)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        plot(target_x_position_inmeters,target_y_position_inmeters,'x')
                        grid on;
                        axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                        title('Observations vs. targets')
                        hold on
                    end
                end
                for d = 1:length(handles.targets(:,s))
                    if isstruct(handles.targets{d,s})
                        observation_x_position_inmeters = ((handles.targets{d,s}.position(1)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        observation_y_position_inmeters = ((handles.targets{d,s}.position(2)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        plot(observation_x_position_inmeters,observation_y_position_inmeters,'o')
                        hold on
                        radius_inmeters = (handles.targets{d,s}.radius).*handles.precision;
                        plot(observation_x_position_inmeters+radius_inmeters.*cos(t),observation_y_position_inmeters+radius_inmeters.*sin(t))
                        grid on;
                        axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                        title('Observations vs. targets')
                        hold on
                    end
                end
            end 

        % Target tracking
            if ~isempty(handles.targets(:,s))
                for b = 1:length(handles.targets(:,s))
                    if isstruct(handles.targets{b,s})
                        hold on
                        axes(handles.axes16)
                        handles.axes16.FontSize = 8;
                        target_x_position_inmeters = ((handles.targets{b,s}.position(1)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        target_y_position_inmeters = ((handles.targets{b,s}.position(2)).*handles.precision+dimensions(1,1))-handles.precision/2;
                        plot(target_x_position_inmeters,target_y_position_inmeters,'w*')
                        grid on;
                        axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                        title('Target Tracking')
                        hold on
                        ln = findobj(handles.axes16,'type','line');
                        set(ln, 'marker', '.', 'markers', 1, 'Color', 'w')
                        if handles.targets{b,s}.target_type == 'candidate'
                            text(target_x_position_inmeters,target_y_position_inmeters,num2str(handles.targets{b,s}.ID), 'Color', [89 11 0]./255, 'FontSize',9)
                        elseif handles.targets{b,s}.target_type == 'confirmed'
                            text(target_x_position_inmeters,target_y_position_inmeters,num2str(handles.targets{b,s}.ID), 'Color', [81 143 9]./255,'Fontsize',9)
                        else
                            text(target_x_position_inmeters,target_y_position_inmeters,num2str(handles.targets{b,s}.ID), 'Color', 'm')
                        end                
                    end
                end
            else
                axes(handles.axes16)
                handles.axes16.FontSize = 8;
                plot(0,0)
            end
            
            % Kalman Estimation
            for b = 1:length(handles.kalman_targets(:,s))
                if isstruct(handles.kalman_targets{b,s}) 
                        target_x_position_inmeters = ((handles.kalman_targets{b,s}.X_est(1)).*handles.precision+handles.xmin)-handles.precision/2;
                        target_y_position_inmeters = ((handles.kalman_targets{b,s}.X_est(2)).*handles.precision+handles.ymin)-handles.precision/2;      
                        axes(handles.axes17)
                        hold on
                        plot(target_x_position_inmeters,target_y_position_inmeters,'x','Color',[41 92 120]./255)
                        grid on;
                        axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                        title('Kalman Filtering')
                        handles.axes17.FontSize = 8;
                end
            end
            
            % Particle Estimation
            for b = 1:length(handles.particle_targets(:,s))
                if isstruct(handles.particle_targets{b,s}) 
                        target_x_position_inmeters = ((handles.particle_targets{b,s}.particle_X_est(1)).*handles.precision+handles.xmin)-handles.precision/2;
                        target_y_position_inmeters = ((handles.particle_targets{b,s}.particle_X_est(2)).*handles.precision+handles.ymin)-handles.precision/2;
                        axes(handles.axes18)
                        hold on
                        plot(target_x_position_inmeters,target_y_position_inmeters,'x', 'Color', [120 18 62]./255)
                        grid on;
                        axis([dimensions(1,1) dimensions(1,2) dimensions(2,1) dimensions(2,2)])
                        title('Particle Filtering')
                end
            end 
            pause(0.5)
        end
    end
    set(handles.button_play_tracking,'String','Play');
    


% --- Executes on button press in button_stop_tracking.
function button_stop_tracking_Callback(hObject, eventdata, handles)
% hObject    handle to button_stop_tracking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ini_step;
ini_step = 1;
set(handles.button_play_tracking,'String','Play');
set(handles.button_stop_tracking,'Enable','Off');

axes(handles.axes11)
cla
axes(handles.axes12)
cla
axes(handles.axes13)
cla
axes(handles.axes14)
cla
axes(handles.axes15)
cla
axes(handles.axes16)
cla
axes(handles.axes17)
cla
axes(handles.axes18)
cla


% --- Executes on selection change in popupmenu_quantizer.
function popupmenu_quantizer_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_quantizer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
quantizer_bits = cellstr(get(handles.popupmenu_quantizer,'String'));
handles.Nbits = str2double(quantizer_bits{get(handles.popupmenu_quantizer,'Value')});

% Update handles structure
guidata(hObject, handles);
% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_quantizer contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_quantizer


% --- Executes during object creation, after setting all properties.
function popupmenu_quantizer_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_quantizer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
quantizer_bits = cellstr(get(hObject,'String'));
handles.Nbits = str2double(quantizer_bits{get(hObject,'Value')});
% Update handles structure
guidata(hObject, handles);
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function text_channel_BER_Callback(hObject, eventdata, handles)
% hObject    handle to text_channel_BER (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%  Channel BER 
handles.channel_BER = str2double(get(handles.text_channel_BER,'String'));

% Update handles structure
guidata(hObject, handles);

% Hints: get(hObject,'String') returns contents of text_channel_BER as text
%        str2double(get(hObject,'String')) returns contents of text_channel_BER as a double


% --- Executes during object creation, after setting all properties.
function text_channel_BER_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_channel_BER (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

%  Channel BER 
handles.channel_BER = str2double(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
