function sensors_data = sensor_quantization(rss_change_link, Nbits)
%SENSOR_QUANTIZATION This function transforms the values of sensor
%measurements into quantified values that sensors will transmit

%   rss_change_link     Change of the RSS by each link according to the
%                       ellipse model (nLinksxsteps)
%   Nbits   Quantization bits --> Must be an integer from 2 to 32 (e.g. Nbits = 3 --> Nvalues = 2^3 = 8 (3 bits can represent 8 values)).
%   sensors_data        Data that sensors will transmit to the fusion center FC

    sensors_data1 = floor(rss_change_link);
    sensors_data2 = sensors_data1 - max(max(sensors_data1))/2;
    sensors_data3 = uencode(sensors_data2, Nbits, max(max(sensors_data2)));
    sensors_data = double(sensors_data3);
    
end

